/* Core Functions
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Image Loader.

The Imote2 Image Loader is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Imote2 Image Loader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Imote2 Image Loader. If not, see <http://www.gnu.org/licenses/>.
*/

#include "core.h"
#include <core/cache.h>
#include <core/mmu.h>

void _mmuTableLoad();

void _coreHardwareInitMMU() {
	_mmuTableLoad();
	_coreHardwareInit();
}

void _coreHardwareInit() {
	iCacheEnable();
	dCacheEnable();
	btbEnable();
}

void _coreHardwareClean() {
	/* unlock caches and tlb */
	iCacheUnlock();
	dCacheUnlock();
	iTlbUnlock();
	dTlbUnlock();
	/* clean and invalidate caches and tlb */
	dCacheClean();
	iAndDCacheInvalidate();
	iAndDTlbInvalidate();
}

